package com.osgi.bundle;

import java.util.Dictionary;
import java.util.Hashtable;

import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleActivator;

import org.osgi.service.event.EventHandler;
import org.osgi.service.event.EventConstants;

import org.osgi.framework.ServiceRegistration;

public class ExchangeActivator implements BundleActivator
{
	private ServiceRegistration<?>  service_currency;
	private ServiceRegistration<?>  service_bundle;
    //--------------------------------------------------------------------------------------
    @Override
    public void start(BundleContext context) throws Exception
    {
    	System.out.println("   start : bundle-exchange");

    	ExchangeSubscriber monitor = new ExchangeSubscriber();

    	// Подключение слушателя
    	Dictionary<String, Object> dict1 = new Hashtable<String, Object>();
    	dict1.put(EventConstants.EVENT_TOPIC, "org/osgi/framework/BundleEvent/*");
    	service_currency = context.registerService(EventHandler.class.getName(), monitor, dict1);

    	if (service_currency != null)
    		System.out.println("\nExchangeActivator : Service 'org/osgi/framework/BundleEvent/*' is registered\n");
    	else
    		System.out.println("ExchangeActivator : Service 'org/osgi/framework/BundleEvent/*' is not registered");

    	// Подключение слушателя
    	Dictionary<String, Object> dict2 = new Hashtable<String, Object>();
    	dict2.put(EventConstants.EVENT_TOPIC, "service/event/Currency");
//    	ExchangeSubscriber monitor = new ExchangeSubscriber();
    	service_bundle = context.registerService(EventHandler.class.getName(), monitor, dict2);

    	if (service_bundle != null)
    		System.out.println("\nExchangeActivator : Service 'service/event/Currency' is registered\n");
    	else
    		System.out.println("ExchangeActivator : Service 'service/event/Currency' is not registered");
    }
    //--------------------------------------------------------------------------------------
    @Override
    public void stop(BundleContext context) throws Exception
    {
    	if (service_bundle != null) {
    		service_bundle.unregister();
    		service_bundle = null;
    	}
    	if (service_currency != null) {
    		service_currency.unregister();
    		service_currency = null;
    	}
        System.out.println("stop : bundle-exchange");
    }
    //--------------------------------------------------------------------------------------
}
