package com.osgi.bundle;

import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.ServiceReference;

import org.osgi.service.event.EventAdmin;

// g! felix:install file:bundles/bundle-publisher-1.0.0.jar

public class PublisherActivator implements BundleActivator
{
	private  EventPublisher  eventPublisher;
	private  final String[]  curencies = {"rub", "usd", "eur"};
	private  int             idx       = 0;
    //--------------------------------------------------------------------------------------
    @Override
    public void start(BundleContext context) throws Exception
    {
        System.out.println("  START : bundle-publisher");

        eventPublisher = createPublisher(context);
    	if (eventPublisher != null) {
    		new Thread(new Runnable() {
    			@Override
    			public void run() {
    				while (true) {
    					try {
    						eventPublisher.sendCurrencyEvent(curencies[idx++]);
    						if (idx > 2)
    							break;
    						Thread.sleep(1000);
    					} catch (InterruptedException ex) {}
    				}
    			}
    		}).start();    		
    	}
    }
    //--------------------------------------------------------------------------------------
    @Override
    public void stop(BundleContext context) throws Exception
    {
        System.out.println("stop : bundle-publisher");
    }
    //--------------------------------------------------------------------------------------
    @SuppressWarnings("unchecked")
	private EventPublisher createPublisher(BundleContext context) 
    {
    	EventPublisher publisher = null;
    	ServiceReference<EventAdmin> ref = (ServiceReference<EventAdmin>) 
                                            context.getServiceReference(EventAdmin.class.getName());
    	if (ref != null) {
    		EventAdmin eventAdmin = (EventAdmin) context.getService(ref);
    		if (eventAdmin != null)
    			publisher = new EventPublisher(eventAdmin);
    		else
    			System.out.println("      ERROR : eventAdmin is null");
    	} 
    	return publisher;
    }
    //--------------------------------------------------------------------------------------
//	@Override
//	public void serviceChanged(ServiceEvent serviceEvent)
//	{
//		switch (serviceEvent.getType()) {
//			case ServiceEvent.REGISTERED: {
//				System.out.println("bundle-exchange : serviceChanged (ServiceEvent.REGISTERED)");
//				ICurrency service = (ICurrency) bundleContext.getService(
//		                                        serviceEvent.getServiceReference());
//				if (service != null) {
//					System.out.println("   service != null");
//					System.out.println("   currency.currency = " + service.getCurrency());
//				} else {
//					System.out.println("   service == null");
//				}
//				break;
//			}
//    		case ServiceEvent.UNREGISTERING : {
//    			bundleContext.ungetService(serviceEvent.getServiceReference());
//				System.out.println("bundle-exchange : serviceChanged (ServiceEvent.UNREGISTERING)");
//    			break;
//    		}
//			default:
//				// 	do nothing
//		}
//	}
//	//--------------------------------------------------------------------------------------
}
